'MMEDIT!!! Basic Version = CMM2
'MMEDIT!!! Port = COM10:38400:10,300
'MMEDIT!!! Device = CMM2
'MMEDIT!!! Config = 1001111011200100100200000100010
  ' TassyJim Jun2020
  ' PS2 mouse to serial interface demo
  ' Arduino sends 3 bytes
  ' X movement - signed byte,Y movement - signed byte,Button states - byte
  ' for micromites that don't do sprites, comment out those lines.
  ' Maximite running V4.5 will have to change the CIRCLE and TEXT commands
  ' early Maximites will also need to change Colour and INTEGER
  
  DIM INTEGER mouseX, mouseY, mouseB, mouseR, mouseL, mouseM  ' mouse position and buttons
  DIM INTEGER mouseMove, mouseClick ' flags to indicate mouse movement or button change
  DIM INTEGER mc ' mouse colour
  
  SPRITE LOAD "mouse.spr",5
  OPEN "com1: 19200,256,mousetrap,3" AS #2 ' 19200 is the fastest that all Maximie/micromites can handle
  initM
  
  DO
    IF INKEY$ = " " THEN initM ' might be needed if the mouse interface is interrupted.
    
    IF mouseMove = 1 THEN
      IF mouseX < 0 THEN mouseX = 0 ' keep the pionter on the screen
      IF mouseY < 0 THEN mouseY = 0
      IF mouseX >= MM.HRES THEN mouseX = MM.HRES -1
      IF mouseY >= MM.VRES THEN mouseY = MM.VRES -1
      drawIt
      mouseMove = 0
    ENDIF
    
    IF mouseClick = 1 THEN
      mouseR = (mouseB AND 2)/2 ' extract the individual button states
      mouseL = (mouseB AND 1)
      mouseM = (mouseB AND 4)/4
      IF mouseL = 1 THEN mc = RGB(RED)
      IF mouseR = 1 THEN mc = RGB(GREEN)
      IF mouseL = 1 AND mouseR = 1 THEN mc = RGB(BLUE)
      drawIt
      mouseClick = 0
    ENDIF
  LOOP
  
  CLOSE #2
  
SUB initM
  LOCAL j$
  j$ = INPUT$(255,#2) ' flush the serial buffer
  mouseX = MM.HRES/2
  mouseY = MM.VRES/2
  CLS
  SPRITE SHOW 5,mouseX,mouseY,1
END SUB
  
SUB drawIt
  TEXT 10,10, STR$(mouseX)+" "+STR$(mouseY)+" "+STR$(mouseL)+" "+STR$(mouseM)+" "+STR$(mouseR)
  SPRITE HIDE 5 ' hide the cursor while we draw
  IF (mouseL + mouseR) > 0 THEN ' only draw if a button is pressed
    CIRCLE mouseX, mouseY, 3, 1,1,mc,mc
    'circle(mouseX, mouseY),3,mc,1,F ' CMM V1
  ENDIF
  SPRITE SHOW 5,mouseX,mouseY,1
END SUB
  
SUB mousetrap
  LOCAL INTEGER deltaB, deltaX, deltaY
  deltaX = ASC(INPUT$(1,#2))  ' read 3 bytes
  deltaY = ASC(INPUT$(1,#2))
  deltaB = ASC(INPUT$(1,#2)) AND 7
  IF deltaX > 127 THEN deltaX = deltaX - 256 ' signed 8 bit integer
  IF deltaY > 127 THEN deltaY = deltaY - 256
  IF mouseB <> deltaB THEN    '  buttons have changed
    mouseClick = 1            ' set the flag
    mouseB = deltaB           ' remember button states
  ENDIF
  IF deltaX <>0 OR deltaY <> 0 THEN  ' mouse has moved
    mouseMove = 1             ' set the flag
    mouseX = mouseX + deltaX
    mouseY = mouseY - deltaY
  ENDIF
END SUB
  